﻿------------------------------------------------------------------------------------------------------------------------------------
-- Duugu's Speech Modifier (1.1)
--   by Duugu ("Die silberne Hand", Horde, EU)
--
------------------------------------------------------------------------------------------------------------------------------------
-- History
-- 1.1
--   - Added french translation
--     Thanks a lot to Shanaya :)
-- 1.0
--   First version
------------------------------------------------------------------------------------------------------------------------------------
--~ SpeechModifier_Version = "1.1";
--~ SpeechModifier_Yellow = "|cffffff00";
--~ SpeechModifier_White = "|cffffffff";
--~ SpeechModifier_ON = "Duugu's Speech Modifier is activated";
--~ SpeechModifier_OFF = "Duugu's Speech Modifier is deactivated";
--~ SpeechModifier_UNMODIFIED = "Unmodified";
--~ SpeechModifier_LOADED = "Duugu's Speech Modifier ("..SpeechModifier_Version..") loaded";
--~ SpeechModifier_HELP1 = SpeechModifier_Yellow.."Duugu's Speech Modifier:";
--~ SpeechModifier_HELP2 = SpeechModifier_Yellow.."/sm"..SpeechModifier_White.." or "..SpeechModifier_Yellow.."/speechmodifier"..SpeechModifier_White.." to activate and deactivate addon";
--~ SpeechModifier_HELP3 = SpeechModifier_Yellow.."/sm say"..SpeechModifier_White.." or "..SpeechModifier_Yellow.."/speechmodifier say"..SpeechModifier_White.." to enable Speech Modifier only for 'say' channel";
--~ SpeechModifier_HELP4 = SpeechModifier_Yellow.."/sm [language]"..SpeechModifier_White.." or "..SpeechModifier_Yellow.."/speechmodifier [language]"..SpeechModifier_White.." to select a language";
--~ SpeechModifier_SAYSW1 = SpeechModifier_Yellow.."Speech Modifier only for 'say'";
--~ SpeechModifier_SAYSW2 = SpeechModifier_Yellow.."Speech Modifier for all channels";
--~ SpeechModifier_MSG1 = " (Language is ";
--~ SpeechModifier_MSG2 = " - only SAY)";
--~ SpeechModifier_MSG3 = " - all channels)";
------------------------------------------------------------------------------------------------------------------------------------
local SpeechModifier_Old_SendChatMessage;

-- these vars are saved per character
SpeechModifier_ActLang = SpeechModifier_UNMODIFIED; -- active language
SpeechModifier_OnOff = false; -- addon activated/deactivated
SpeechModifier_Say = false; -- translate only in say

-- to change all lower case utf-8 chars to upper case (couldn't figure out a better way to do this :/ )
-- simply add possible missing utf-8 chars to the list
SpeechModifierCaps = 	{
						["ä"] = "Ä",
						["ö"] = "Ö",
						["ü"] = "Ü",
						["â"] = "Â",
						["ê"] = "Ê",
						["î"] = "Î",
						["ô"] = "Ô",
						["û"] = "Û",
						["á"] = "Á",
						["é"] = "É",
						["í"] = "Í",
						["ó"] = "Ó",
						["ú"] = "Ú",
						["ý"] = "Ý",
						["à"] = "À",
						["è"] = "È",
						["ì"] = "Ì",
						["ò"] = "Ò",
						["ù"] = "Ù",
						["ß"] = "ß"
						}
------------------------------------------------------------------------------------------------------------------------------------
-- add all languages to chat frame dropdown list
------------------------------------------------------------------------------------------------------------------------------------
function SpeechModifier_LoadLanguages()
	UIMenu_AddButton(SpeechModifier_White.."----------", nil, nil);
	for i, v in pairs(SpeechModifierTranslations) do 
		if i == "None" then
			UIMenu_AddButton(SpeechModifier_White..SpeechModifier_UNMODIFIED, nil, LanguageMenu_Click);
		else
			UIMenu_AddButton(SpeechModifier_White..i, nil, LanguageMenu_Click);
		end
	end
end
------------------------------------------------------------------------------------------------------------------------------------
-- handle clicks for language dropdown
------------------------------------------------------------------------------------------------------------------------------------
function SpeechModifier_LanguageMenu_Click()
	SpeechModifier_OnOff = false
	SpeechModifier_ActLang = "None";
	local tmpLang = string.sub(this:GetText(), string.len(SpeechModifier_White) + 1);
	if tmpLang == SpeechModifier_UNMODIFIED then
		tmpLang = "None";
	end
	for i, v in pairs(SpeechModifierTranslations) do 
		if tmpLang == i then
			SpeechModifier_OnOff = true
			SpeechModifier_ActLang = i;
		end
	end

	if SpeechModifier_Say == true then
		if SpeechModifier_ActLang == "None" then
			DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_UNMODIFIED..SpeechModifier_MSG2);
		else
			DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_ActLang..SpeechModifier_MSG2);
		end
	else
		if SpeechModifier_ActLang == "None" then
			DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_UNMODIFIED..SpeechModifier_MSG3);
		else
			DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_ActLang..SpeechModifier_MSG3);
		end
	end
	
	
end
------------------------------------------------------------------------------------------------------------------------------------
-- modify outgoing chat messages
------------------------------------------------------------------------------------------------------------------------------------
function SpeechModifierSendChatMessage(msg, chattype, language, channel)
	if msg then
		if msg ~= "" and msg ~= " " then
			if SpeechModifier_OnOff == true then
				if SpeechModifier_Say == false or (SpeechModifier_Say == true and chattype == "SAY") then
					for Original, Translation in pairs(SpeechModifierTranslations[SpeechModifier_ActLang]) do 
						-- replace every original that starts with a lower char
						msg = string.gsub(msg, Original, Translation);
						-- replace every original that starts with a upper char
						-- first char is a damn utf-8 code
						if string.byte(string.sub(Original, 1, 1)) == 195 then
							if SpeechModifierCaps[string.sub(Original, 1, 2)] then
								local OriginalTmp = SpeechModifierCaps[string.sub(Original, 1, 2)];
								if string.len(Original) > 2 then
									OriginalTmp = OriginalTmp..string.sub(Original, 3);
								end
								Original = OriginalTmp;
								if SpeechModifierCaps[string.sub(Translation, 1, 2)] then
									local TranslationTmp = SpeechModifierCaps[string.sub(Translation, 1, 2)];
									if string.len(Translation) > 2 then
										TranslationTmp = TranslationTmp..string.sub(Translation, 3);
									end
									Translation = TranslationTmp;
								else
									local TranslationTmp = string.upper(string.sub(Translation, 1, 1));
									if string.len(Translation) > 1 then
										TranslationTmp = TranslationTmp..string.sub(Translation, 2);
									end
									Translation = TranslationTmp;
								end
								msg = string.gsub(msg, Original, Translation);
							end
						-- no utf-8
						else
							local OriginalTmp = string.upper(string.sub(Original, 1, 1));
							if string.len(Original) > 1 then
								OriginalTmp = OriginalTmp..string.sub(Original, 2);
							end
							local TranslationTmp = string.upper(string.sub(Translation, 1, 1));
							if string.len(Translation) > 1 then
								TranslationTmp = TranslationTmp..string.sub(Translation, 2);
							end
							Original = OriginalTmp;
							Translation = TranslationTmp;
							msg = string.gsub(msg, Original, Translation);
						end
					end 
				end
			end
		end
	end
	
	-- finally send the modified text
	SpeechModifier_Old_SendChatMessage(msg, chattype, language, channel);
end
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
function SpeechModifierOnLoad()
	DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_LOADED);
	
	SLASH_SpeechModifier1 = "/sm";
	SLASH_SpeechModifier2 = "/speechmodifier";
	SlashCmdList["SpeechModifier"] = SpeechModifierOnOff;
	
	-- hook LanguageMenu_LoadLanguages and LanguageMenu_Click for language dropdown handling
	hooksecurefunc("LanguageMenu_LoadLanguages", SpeechModifier_LoadLanguages);
	hooksecurefunc("LanguageMenu_Click", SpeechModifier_LanguageMenu_Click);
	-- hook SendChatMessage to intercept sends and modify text before sending it out
	SpeechModifier_Old_SendChatMessage = SendChatMessage;
	SendChatMessage = SpeechModifierSendChatMessage;

	this:RegisterEvent("VARIABLES_LOADED"); 	
end
------------------------------------------------------------------------------------------------------------------------------------
-- handle slash commands
------------------------------------------------------------------------------------------------------------------------------------
function SpeechModifierOnOff(cmd)
	if cmd == "help" or cmd == "hilfe" or cmd == "?" or cmd == "Hilfe" then
		DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_HELP1);
		DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_HELP2);
		DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_HELP3);
		DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_HELP4);
		DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_HELP5);
	else
		-- found parameter
		if cmd and cmd ~= "" then
			if string.lower(cmd) == "say" then
				-- switch say option
				if SpeechModifier_Say == false then
					SpeechModifier_Say = true;
					DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_SAYSW1);
				else
					SpeechModifier_Say = false;
					DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_SAYSW2);
				end
			elseif string.lower(cmd) == "list" then
				DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_DICTIONARY..":");
				for i, v in pairs(SpeechModifierTranslations) do 
					if i == "None" then
						DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow.."- "..SpeechModifier_UNMODIFIED);
					else
						DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow.."- "..i);
					end
				end
			else
				-- switch to language
				for i, v in pairs(SpeechModifierTranslations) do 
					if cmd == SpeechModifier_UNMODIFIED then
						cmd = "None";
					end
					if string.lower(cmd) == string.lower(i) then
						SpeechModifier_OnOff = true
						SpeechModifier_ActLang = i;
						if SpeechModifier_ActLang == "None" then
							DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_UNMODIFIED..")");
						else
							DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_ActLang..")");
						end
					end
				end
			end
		else
			-- activate / deactivate addon
			if SpeechModifier_OnOff == false then
				SpeechModifier_OnOff = true
				DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON);
			else
				SpeechModifier_OnOff = false
				SpeechModifier_ActLang = "None";
				DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_OFF);
			end
		end
	end
end
------------------------------------------------------------------------------------------------------------------------------------
--
------------------------------------------------------------------------------------------------------------------------------------
function SpeechModifierOnEvent(event)
	if event == "VARIABLES_LOADED" then
		-- set language to default if active language is nil
		if not SpeechModifierTranslations[SpeechModifier_ActLang] then
			SpeechModifier_ActLang = "None";
		end
		
		if SpeechModifier_OnOff == false then
			DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_OFF);
		else
			if SpeechModifier_Say == true then
				if SpeechModifier_ActLang == "None" then
					DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_UNMODIFIED..SpeechModifier_MSG2);
				else
					DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_ActLang..SpeechModifier_MSG2);
				end
			else
				if SpeechModifier_ActLang == "None" then
					DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_UNMODIFIED..SpeechModifier_MSG3);
				else
					DEFAULT_CHAT_FRAME:AddMessage(SpeechModifier_Yellow..SpeechModifier_ON..SpeechModifier_MSG1..SpeechModifier_ActLang..SpeechModifier_MSG3);
				end
			end
		end
	
	end
end
